﻿using System;
using System.Drawing;
using Wisej.Web;

namespace Wisej_DragDropSample
{
	public partial class Page1 : Page
	{
		public Page1()
		{
			InitializeComponent();
		}

		private void Page1_Load(object sender, System.EventArgs e)
		{
			//FixDragDropForButton();

			var label = new Label
			{
				Text = "Drag me",
				AllowDrag = true,
				Parent = this.flowLayoutPanel1
			};

			//------ ADD Event to Newly added Control that allow it to be Drug  (lol) Dragged 
			label.DragStart += Control_DragStart;

			var button = new Button
			{
				Text = "Drag me",
				AllowDrag = true,
				Parent = this.flowLayoutPanel1
			};
			button.DragStart += Control_DragStart;


			//-----------------  DEV test BazAckwards::

			var btnCtrlReferenceX = new Button
			{
				Text = "DragAzzBak",
				BackColor = Color.Green,
				AllowDrag = true,
				Parent = this.flowLayoutPanel2
			};
			btnCtrlReferenceX.DragStart += Control_DragStart;



			btnCtrlReferenceX.Click += ButtonAzzBak_Click;




			// SET the Panel Properties to Allow Drop
			this.flowLayoutPanel1.AllowDrop = true;
			this.flowLayoutPanel2.AllowDrop = true;




			this.flowLayoutPanel1.DragEnter += Panel_DragEnter;
			this.flowLayoutPanel2.DragEnter += Panel_DragEnter;

			this.flowLayoutPanel1.DragDrop += Panel_DragDrop;
			this.flowLayoutPanel2.DragDrop += Panel_DragDrop;
		}

		private void ButtonAzzBak_Click(object sender, EventArgs e)
		{
			// This doesnt work it doesnt know destination panel 
			Control_DragStart(sender, e);
		}

		//private void FixDragDropForButton()
		//{
		//	this.InitScript = @"
		//		var dragDrop = qx.event.Registration.getManager(window).getHandler(qx.event.handler.DragDrop);
		//		dragDrop.__manager.removeListener(dragDrop.__root, ""pointerdown"", dragDrop._onPointerdown, dragDrop);
		//		dragDrop.__manager.addListener(dragDrop.__root, ""pointerdown"", dragDrop._onPointerdown, dragDrop, true);";
		//}

		private void Panel_DragDrop(object sender, DragEventArgs e)
		{
			var panel = (Control)sender;
			var control = e.DragSource;
			if (control != null)
			{
				control.Parent = panel;
			}
		}
        // One Way ===>   receiver gets        this.pnlOrders.DragDrop += new Wisej.Web.DragEventHandler(this.UnloadTruck);

        private void Panel_DragEnter(object sender, DragEventArgs e)
		{
			e.Effect = DragDropEffects.Move;
		}

		private void Control_DragStart(object sender, System.EventArgs e)
		{
			var control = (Control)sender;
			control.DoDragDrop(null, DragDropEffects.Move);
		}
	}
}
